/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ciphermemo;

/*
* A simple font dialog
* Author: Danny Battison
* Contact: gabehabe@googlemail.com
*/

/*
 * changed by Kanemitsu
 */


/*
* first off, let's take a look at the FontChooser class, which inherits
* JPanel (don't be put off, a lot of this code is simply the GUI design)
*/

 import java.awt.*;
 import java.awt.event.*;
 import javax.swing.*;
 import javax.swing.event.*;

 class FontChooser extends JPanel
 {
        // all variables, aside from the final public Font are simply for the UI of the class
         private JLabel Preview;
         private JComboBox FontSize;
         private JList FontList;
         private JScrollPane jScrollPane1;
         private JList Style;
         private JScrollPane jScrollPane2;
         public  JButton OK_Button;
         private JButton Cancel_Button;
         // the SelectedFont attribute can be accessed by other classes
         public  Font SelectedFont;
         private FontDialog Parent;
         
         public FontChooser(FontDialog parent, Font defaultFont) {
                 super();
                 initialiseComponent();
                 String[] fonts = GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
                 this.FontList.setListData(fonts);
                 
                 for (int i = 8; i <= 72; i += 2) {
                         this.FontSize.addItem((Integer)i);
                 }
                 
                 String[] styles = {"Regular", "Italic", "Bold", "Bold Italic"};
                 this.Style.setListData(styles);
                 this.Parent = parent;
                 
                 if (defaultFont != null) {
                     ListModel model = this.FontList.getModel();
                     
                     for (int i = 0, len = model.getSize(); i < len; ++i) {
                         if (((String)model.getElementAt(i)).equals(defaultFont.getFamily())) {
                             this.FontList.setSelectedIndex(i);
                             this.FontList.ensureIndexIsVisible(i);
                             break;
                         }
                     }
                     
                     for (int i = 0, len = this.FontSize.getItemCount(); i < len; ++i) {
                         if (defaultFont.getSize() == (Integer)this.FontSize.getItemAt(i)) {
                             this.FontSize.setSelectedIndex(i);
                             break;
                         }
                     }
                     
                     if (defaultFont.isPlain()) this.Style.setSelectedIndex(0);
                     else if(defaultFont.isBold() && defaultFont.isItalic()) this.Style.setSelectedIndex(3);
                     else if(defaultFont.isBold()) this.Style.setSelectedIndex(1);
                     else if(defaultFont.isItalic()) this.Style.setSelectedIndex(2);
                 }
         }

         private void initialiseComponent() {
                 this.Preview = new JLabel();
                 this.Preview.setText("Preview");
                 
                 this.FontSize = new JComboBox();
                 this.FontSize.setFont(new Font("", 0, 16));
                 
                 this.FontList = new JList();
                 this.FontList.setFont(new Font("", 0, 16));
                 
                 this.Style = new JList();
                 this.Style.setFont(new Font("", 0, 16));
                 
                 this.jScrollPane1 = new JScrollPane();
                 this.jScrollPane2 = new JScrollPane();
                 
                 this.OK_Button = new JButton();
                 this.OK_Button.setFont(new Font("", 0, 16));
                 
                 this.Cancel_Button = new JButton();
                 this.Cancel_Button.setFont(new Font("", 0, 16));


                 this.FontSize.addActionListener(new ActionListener() {
                         public void actionPerformed(ActionEvent e) {
                                 FontChanged();
                         }
                 });
                 this.FontList.addListSelectionListener(new ListSelectionListener() {
                         public void valueChanged(ListSelectionEvent e) {
                                 FontChanged();
                         }
                 });

                 this.jScrollPane1.setViewportView(this.FontList);

                 this.Style.addListSelectionListener(new ListSelectionListener() {
                         public void valueChanged(ListSelectionEvent e) {
                                 FontChanged();
                         }
                 });

                 this.jScrollPane2.setViewportView(this.Style);

                 this.OK_Button.setText("OK");
                 this.OK_Button.addActionListener(new ActionListener() {
                         public void actionPerformed(ActionEvent e) {
                                 OK_Button_actionPerformed(e);
                         }
                 });

                 this.Cancel_Button.setText("Cancel");
                 this.Cancel_Button.addActionListener(new ActionListener() {
                         public void actionPerformed(ActionEvent e) {
                                 Cancel_Button_actionPerformed(e);
                         }
                 });

                 this.setLayout(null);
                 addComponent(this, this.Preview, 18,166,132,27);
                 addComponent(this, this.FontSize, 231,15,100,22);
                 addComponent(this, this.jScrollPane1, 15,14,196,131);
                 addComponent(this, this.jScrollPane2, 231,47,100,100);
                 addComponent(this, this.OK_Button, 158,166,83,28);
                 addComponent(this, this.Cancel_Button, 248,165,83,28);

                 this.setLocation(new Point(100,100));
                 this.setSize(new Dimension(360, 242));
         }

         private void addComponent(Container container,Component c,int x,int y,int width,int height) {
                 c.setBounds(x,y,width,height);
                 container.add(c);
         }

         private void FontChanged() {
                 try {
                        int size = this.FontSize.getSelectedIndex()*2 + 8;
                        String name = this.FontList.getSelectedValue().toString();
                        if (this.Style.getSelectedIndex() == 0) // Regular
                                this.SelectedFont = new Font(name, Font.PLAIN, size);
                        else if (this.Style.getSelectedIndex() == 1) // Italic
                                this.SelectedFont = new Font(name, Font.ITALIC, size);
                        else if (this.Style.getSelectedIndex() == 2) // Bold
                                this.SelectedFont = new Font(name, Font.BOLD, size);
                        else if (this.Style.getSelectedIndex() == 3) // Bold Italic
                                this.SelectedFont = new Font(name, Font.BOLD+Font.ITALIC, size);
                        else // default, none selected
                                this.SelectedFont = new Font(name, Font.PLAIN, size);
                        this.Preview.setFont(this.SelectedFont);
                 } catch (Exception ex) {
                         System.out.println(ex.getMessage());
                 }
         }

         private void OK_Button_actionPerformed(ActionEvent e) {
                 this.Parent.setVisible(false);
                 // the font has been saved in memory
         }

         private void Cancel_Button_actionPerformed(ActionEvent e) {
                 this.SelectedFont = null;
                 this.Parent.setVisible(false);
         }
}

/*
* And now let's look at the FontDialog class (this one's shorter)
*/


public class FontDialog extends JDialog {
        private FontChooser chooser;
        public FontDialog(Font defaultFont)
        {
            this.chooser = new FontChooser(this, defaultFont);
            this.setSize(new Dimension(360, 242));
            this.getContentPane().add(chooser);
            this.setModal(true);
            this.setLocationRelativeTo(null);
            this.setTitle("フォント選択");
        }

        public Font showDialog()
        {
            this.setVisible(true);
            return this.chooser.SelectedFont;
        }
}
