/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * jDialog_KeyInput.java
 *
 * Created on 2010/11/04, 11:42:10
 */

package ciphermemo;

import java.awt.Color;
import java.awt.Frame;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.Arrays;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

/**
 *
 * @author kanemitsu
 */
public class jDialog_KeyInput extends javax.swing.JDialog implements FocusListener{
    private static final Color FOCUS_GAINED_COLOR = new Color(0xFFFFDF);
    private static final Color FOCUS_LOST_COLOR = new Color(0xFAFAFA);
    
    private boolean okFlag = false;

    //鍵の有効期間(ミリ秒)
    private static long timeLimit = 1000 * 60 * 5;

    public static long getTimeLimit() {
        return timeLimit;
    }


    public static byte[] showKeyInputDialog(Frame parent) throws UnsupportedEncodingException, FileNotFoundException, IOException {
        jDialog_KeyInput dialog_KeyInput = new jDialog_KeyInput(parent, true);
        dialog_KeyInput.setVisible(true);
        if (!dialog_KeyInput.okFlag) return null;
        
        byte[] key = null;
        if (dialog_KeyInput.jRadioButton_Text.isSelected()) {
            key = (new String(dialog_KeyInput.jPasswordField_Key.getPassword())).getBytes("UTF8");
        }
        else if (dialog_KeyInput.jRadioButton_File.isSelected()) {
            /*
             * 最大27,024バイト(Sfmtの種の上限)ファイルから読み込む
             */
            FileInputStream fis = new FileInputStream(new String(dialog_KeyInput.jPasswordField_Key.getPassword()));
            try {
                if (fis.available() < 27024) {
                    key = new byte[fis.available()];
                }
                else {
                    key = new byte[27024];
                }
                fis.read(key);
            } finally {
                try {
                    fis.close();
                } catch (IOException ex) {
                    Logger.getLogger(jDialog_KeyInput.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        }

        dialog_KeyInput.dispose();
        dialog_KeyInput = null;
        return key;
    }
    
    /** Creates new form jDialog_KeyInput */
    public jDialog_KeyInput(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();

        setLocationRelativeTo(null);
        getRootPane().setDefaultButton(jButton_OK);

        jSpinner_TimeLimit.setValue((Integer)(int)(timeLimit / (1000 * 60)));
        ((JSpinner.NumberEditor)jSpinner_TimeLimit.getEditor()).getTextField().setBackground(FOCUS_LOST_COLOR);
        jPasswordField_Key.setBackground(FOCUS_LOST_COLOR);
        jPasswordField_Key2.setBackground(FOCUS_LOST_COLOR);

        ((JSpinner.NumberEditor)jSpinner_TimeLimit.getEditor()).getTextField().addFocusListener(this);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        jButton_File = new javax.swing.JButton();
        jPasswordField_Key = new javax.swing.JPasswordField();
        jRadioButton_File = new javax.swing.JRadioButton();
        jRadioButton_Text = new javax.swing.JRadioButton();
        jPasswordField_Key2 = new javax.swing.JPasswordField();
        jLabel1 = new javax.swing.JLabel();
        jButton_Cancel = new javax.swing.JButton();
        jButton_OK = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jSpinner_TimeLimit = new javax.swing.JSpinner();
        jLabel2 = new javax.swing.JLabel();

        setTitle("鍵の入力");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "鍵の情報を入力して下さい", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("MS UI Gothic", 1, 16), new java.awt.Color(0, 0, 0))); // NOI18N

        jButton_File.setFont(jButton_File.getFont().deriveFont((float)16));
        jButton_File.setText("参照");
        jButton_File.setToolTipText("<html>このボタンを押すと、ファイルを選択できます。");
        jButton_File.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_FileActionPerformed(evt);
            }
        });

        jPasswordField_Key.setBackground(new java.awt.Color(250, 250, 250));
        jPasswordField_Key.setFont(jPasswordField_Key.getFont().deriveFont((float)16));
        jPasswordField_Key.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                jPasswordField_KeyFocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                jPasswordField_KeyFocusLost(evt);
            }
        });

        buttonGroup1.add(jRadioButton_File);
        jRadioButton_File.setFont(jRadioButton_File.getFont().deriveFont((float)16));
        jRadioButton_File.setText("ファイル");
        jRadioButton_File.setToolTipText("指定されたファイルの内容を鍵とします。");

        buttonGroup1.add(jRadioButton_Text);
        jRadioButton_Text.setFont(jRadioButton_Text.getFont().deriveFont((float)16));
        jRadioButton_Text.setSelected(true);
        jRadioButton_Text.setText("文字列");
        jRadioButton_Text.setToolTipText("テキストボックスに入力された文字列を鍵として使用します。");

        jPasswordField_Key2.setBackground(new java.awt.Color(250, 250, 250));
        jPasswordField_Key2.setFont(jPasswordField_Key2.getFont().deriveFont((float)16));
        jPasswordField_Key2.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                jPasswordField_Key2FocusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                jPasswordField_Key2FocusLost(evt);
            }
        });

        jLabel1.setFont(jLabel1.getFont().deriveFont(jLabel1.getFont().getStyle() | java.awt.Font.BOLD, 16));
        jLabel1.setText("<html>上の2つのテキストボックスに、同じものを入力して下さい。<br>\n鍵が長くなるほど、安全性が向上します。");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(jRadioButton_Text)
                        .addGap(43, 43, 43)
                        .addComponent(jRadioButton_File)
                        .addGap(18, 18, 18)
                        .addComponent(jButton_File, javax.swing.GroupLayout.DEFAULT_SIZE, 92, Short.MAX_VALUE)
                        .addGap(151, 151, 151))
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(jPasswordField_Key2, javax.swing.GroupLayout.Alignment.LEADING)
                        .addComponent(jPasswordField_Key, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 431, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jRadioButton_Text)
                    .addComponent(jRadioButton_File)
                    .addComponent(jButton_File, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(jPasswordField_Key, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jPasswordField_Key2, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(42, 42, 42)
                .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jButton_Cancel.setFont(jButton_Cancel.getFont().deriveFont((float)16));
        jButton_Cancel.setText("Cancel");
        jButton_Cancel.setDefaultCapable(false);
        jButton_Cancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_CancelActionPerformed(evt);
            }
        });

        jButton_OK.setFont(jButton_OK.getFont().deriveFont((float)16));
        jButton_OK.setText("OK");
        jButton_OK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_OKActionPerformed(evt);
            }
        });

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "鍵の有効期間を入力して下さい", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("MS UI Gothic", 1, 16), new java.awt.Color(0, 0, 0))); // NOI18N

        jSpinner_TimeLimit.setFont(jSpinner_TimeLimit.getFont().deriveFont(jSpinner_TimeLimit.getFont().getStyle() | java.awt.Font.BOLD, 16));
        jSpinner_TimeLimit.setModel(new javax.swing.SpinnerNumberModel(Integer.valueOf(5), Integer.valueOf(0), null, Integer.valueOf(1)));
        jSpinner_TimeLimit.setToolTipText("<html>ここで指定した時間が経過すると鍵が無効になり、<br>\n再度鍵の入力が求められます。<br>\n安全性を重視する場合は、\"0\"を指定します。");

        jLabel2.setFont(jLabel2.getFont().deriveFont(jLabel2.getFont().getStyle() | java.awt.Font.BOLD, 16));
        jLabel2.setText("分");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(22, 22, 22)
                .addComponent(jSpinner_TimeLimit, javax.swing.GroupLayout.PREFERRED_SIZE, 155, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jLabel2)
                .addContainerGap(254, Short.MAX_VALUE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jSpinner_TimeLimit, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(147, Short.MAX_VALUE)
                .addComponent(jButton_OK, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(69, 69, 69)
                .addComponent(jButton_Cancel, javax.swing.GroupLayout.PREFERRED_SIZE, 79, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(145, 145, 145))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton_Cancel, javax.swing.GroupLayout.DEFAULT_SIZE, 32, Short.MAX_VALUE)
                    .addComponent(jButton_OK, javax.swing.GroupLayout.DEFAULT_SIZE, 32, Short.MAX_VALUE))
                .addGap(18, 18, 18))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton_OKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_OKActionPerformed
        char[] p1 = jPasswordField_Key.getPassword();
        char[] p2 = jPasswordField_Key2.getPassword();
        
        try {
            if (!Arrays.equals(p1, p2)) {
                JOptionPane.showMessageDialog(this, "入力された鍵が一致しません。\n再度入力をお願いします。");
                jPasswordField_Key.setText("");
                jPasswordField_Key2.setText("");
                return;
            }
        } finally {
            Arrays.fill(p1, (char)0);
            Arrays.fill(p2, (char)0);
        }

        timeLimit = (Integer)jSpinner_TimeLimit.getValue() * 1000 * 60;
        okFlag = true;
        setVisible(false);
    }//GEN-LAST:event_jButton_OKActionPerformed

    private void jButton_FileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_FileActionPerformed
        JFileChooser chooser = new JFileChooser();
        chooser.setAcceptAllFileFilterUsed(true);
        chooser.setMultiSelectionEnabled(false);
        if (JFileChooser.APPROVE_OPTION != chooser.showOpenDialog(this)) return;

        String path = chooser.getSelectedFile().getAbsolutePath();
        jPasswordField_Key.setText(path);
        jPasswordField_Key2.setText(path);
    }//GEN-LAST:event_jButton_FileActionPerformed

    private void jButton_CancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_CancelActionPerformed
        setVisible(false);
    }//GEN-LAST:event_jButton_CancelActionPerformed

    private void jPasswordField_KeyFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jPasswordField_KeyFocusGained
        jPasswordField_Key.setBackground(FOCUS_GAINED_COLOR);
    }//GEN-LAST:event_jPasswordField_KeyFocusGained

    private void jPasswordField_KeyFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jPasswordField_KeyFocusLost
        jPasswordField_Key.setBackground(FOCUS_LOST_COLOR);
    }//GEN-LAST:event_jPasswordField_KeyFocusLost

    private void jPasswordField_Key2FocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jPasswordField_Key2FocusGained
        jPasswordField_Key2.setBackground(FOCUS_GAINED_COLOR);
    }//GEN-LAST:event_jPasswordField_Key2FocusGained

    private void jPasswordField_Key2FocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_jPasswordField_Key2FocusLost
        jPasswordField_Key2.setBackground(FOCUS_LOST_COLOR);
    }//GEN-LAST:event_jPasswordField_Key2FocusLost

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                jDialog_KeyInput dialog = new jDialog_KeyInput(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton jButton_Cancel;
    private javax.swing.JButton jButton_File;
    private javax.swing.JButton jButton_OK;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPasswordField jPasswordField_Key;
    private javax.swing.JPasswordField jPasswordField_Key2;
    private javax.swing.JRadioButton jRadioButton_File;
    private javax.swing.JRadioButton jRadioButton_Text;
    private javax.swing.JSpinner jSpinner_TimeLimit;
    // End of variables declaration//GEN-END:variables

    public void focusGained(FocusEvent e) {
        e.getComponent().setBackground(FOCUS_GAINED_COLOR);
    }

    public void focusLost(FocusEvent e) {
        e.getComponent().setBackground(FOCUS_LOST_COLOR);
    }

}
